"""A record from a single meter from a the meters api."""
from datetime import datetime
from typing import List, Optional
from pydantic import BaseModel


class MeterRecord(BaseModel):
    """Relevant meter data for a power limit notification."""

    reference: str
    utility: Optional[int]
    name: Optional[str]
    version: Optional[str]
    id: Optional[int]
    customer: Optional[int]
    power_limit_triggered: Optional[bool]
    reset_event_reported: Optional[bool]
    timestamp: Optional[str]
    url: Optional[str]
    utility_url: Optional[str]
    utility_name: Optional[str]
    metrics_url: Optional[str]
    bit_harvester: Optional[int]
    bit_harvester_url: Optional[str]
    bit_harvester_name: Optional[str]
    bit_harvester_version: Optional[str]
    customer: Optional[int]
    customer_url: Optional[str]
    customer_name: Optional[str]
    audit_log_url: Optional[str]
    comms_uptime_url: Optional[str]
    connection_is_on: Optional[bool]
    connection_is_on_cloud_command: Optional[bool]
    connection_is_on_scheduled_outage: Optional[bool]
    connection_is_on_local_credit: Optional[bool]
    connection_is_on_power_limiting: Optional[bool]
    directives_url: Optional[str]
    has_ble: Optional[bool]
    has_ciu: Optional[bool]
    pulse_ratio: Optional[float]
    usage_spike_threshold: Optional[float]
    usage_spike_threshold_secondary: Optional[float]
    power_limit: Optional[float]
    power_limit_triggered: Optional[bool]
    tou_power_limit_policy: Optional[str]
    parent_meter: Optional[str]
    parent_meter_url: Optional[str]
    parent_meter_name: Optional[str]
    parent_meter_reference: Optional[str]
    theft_detection_threshold: Optional[float]
    latest_meter_reading_timestamp: Optional[datetime]
    last_bit_harvester_assignment_timestamp: Optional[datetime]
    latitude: Optional[str]
    longitude: Optional[str]
    latest_voltage: Optional[float]
    latest_voltage_timestamp: Optional[str]
    latest_signal_num_packet_errors: Optional[str]
    latest_signal_rssi: Optional[str]
    latest_signal_timestamp: Optional[str]
    labels: Optional[str]
    tags_url: Optional[str]
    tags: Optional[List[str]]
    critical_error_reported: Optional[bool]
    lid_tamper_detection_reported: Optional[bool]
    reset_event_reported: Optional[bool]
    distance_to_bit_harvester: Optional[int]
    comms_outage_indicator: Optional[bool]
